var HAS_MUSIC = 0;
var MUSIC_FILE_WEB_PATH = '';
var AUDIO_MIME_TYPE = '';
var GLOBAL_SOUND_SETTING = 0;
var IS_TV_WIDGET_IN_PORTAL = 'N';
var IS_VIDEO_WIDGET_IN_PORTAL = 'N';
localStorage.setItem('MEDIA_START_UP', 0);

function isPreviewMode() {
    var preview_mode = getCookie('preview_mode');
    if (typeof preview_mode !== 'undefined' && preview_mode != '') {
        return true;
    }
    return false;
}

function tuningCh() {
    var fDoc = getIframeObject();

    var prevChannel = parseInt(getCookie('previous_channel'));
    if (prevChannel > -1){
        setCookie('previous_channel', -1, 365);
        current_channel = prevChannel;
        var physical_channel = getPhysicalChannelInfo(current_channel);
        if (!_.isUndefined(physical_channel) && !_.isEmpty(physical_channel)) {
            param = getChannelParams(physical_channel, 0);

            changeChannel(physical_channel, 0, 0, 'tuningCh', function() {
                if(!_.isNull(fDoc) && fDoc.document.getElementById('pip') !== null) {
                    fDoc.document.getElementById('pip').style.backgroundImage = 'url(tv:)';
                }
            });
        }
        else {
            logConsole('Unable to find physical channel info for ' + current_channel);
        }
    }
    else {
        current_channel = parseInt(getCookie('current_channel'));
        if(!_.isNull(fDoc) && fDoc.document.getElementById('pip') !== null) {
            fDoc.document.getElementById('pip').style.backgroundImage = 'url(tv:)';
        }
    }
}

var BGM = (function () {
    var COMMAND_INTERVAL = 100;
    var IS_LOCKED = false;
    var TASK_QUEUE = [];
    var MEDIA_START_UP = localStorage.getItem('MEDIA_START_UP');

    /* task functions */
    function init() {

    }

    function runTask() {
        if(TASK_QUEUE.length > 0 && !IS_LOCKED) {
            var tasks = TASK_QUEUE.slice(0);

            TASK_QUEUE = [];
            IS_LOCKED = true;
            Promise.resolve(tasks)
                .mapSeries(function(task){
                    return exec(task).delay(COMMAND_INTERVAL);
                })
                .then(function(){
                    IS_LOCKED = false;
                    runTask();
                });
        }
    }

    function exec(task) {
        return BGM[task.name](task.value, task.callback);
    }

    function task(name, value, callback) {
        TASK_QUEUE.push({name: name, value: value, callback: callback});
        runTask();
    }

    /* bgm functions */
    function setTvCaptionUi(value) {
        return hcapPromise.property.setProperty({
            'key': 'tv_caption_ui',
            'value' : _.toString(value),
            'onSuccess': function(s) {
                logConsole('tv_caption_ui is disabled | value = ' + s.value);
            },
            'onFailure': function(e) {
                logConsole('tv_caption_ui onFailure : errorMessage = ' + e.errorMessage);
            }
        });
    }

    function controlMedia(isStart) {
        var method = isStart ? 'startUp' : 'shutDown';
        return hcapPromise.Media[method]({
            'onSuccess' : function() {
                logConsole('Media ' + method + ' onSuccess');
                if(method === 'startUp') {
                    if(parent.CHANNEL_TYPE === 'RF_DATA') {
                        acquireDataChannelWhileBGM();
                    } else if(parent.CHANNEL_TYPE === '') {
                        logConsole('DataChannel for BGM is NOT Initialized yet!!!!!!');
                    }
                }
            },
            'onFailure' : function(e) {
                logConsole('Media ' + method + ' onFailure : errorMessage = ' + e.errorMessage);
            }
        });
    }

    function startMedia() {
        localStorage.setItem('MEDIA_START_UP', 1);
        return setTvCaptionUi(0)
            .then(function() {
                return controlMedia(1);
            })
            .catch(function() {
                localStorage.setItem('MEDIA_START_UP', 0);
            });
    }

    function shutDownMedia(control, callback) {
        var mediaStatsUp = localStorage.getItem('MEDIA_START_UP');
        return controlMedia(0)
            .then(function() {
                var value = control == 2 ? 0 : 1;
                return setTvCaptionUi(value);
            })
            .then(function() {
                _.isFunction(callback) && callback();
                localStorage.setItem('MEDIA_START_UP', 0);
            })
            .catch(function() {
                localStorage.setItem('MEDIA_START_UP', mediaStatsUp);
            });
    }

    function createBgmNode() {
        if(HAS_MUSIC == 0) {
            return Promise.resolve();
        }

        if(isPreviewMode()) {
            addAudioTag();
            return Promise.resolve();
        }

        var MEDIA_START_UP = localStorage.getItem('MEDIA_START_UP');
        if(MEDIA_START_UP != 0) {
            return Promise.resolve();
        }
        localStorage.setItem('MEDIA_START_UP', 1);
        return controlMedia(1)
            .then(function() {
                addAudioTag();
            });
    }

    function addAudioTag() {
        try {
            var audio = $('<audio loop controls=\"controls\" id=\"bgm\" style=\"display:none;\"></audio>');
            var source = $('<source>');
            source.attr('src', MUSIC_FILE_WEB_PATH);
            source.attr('type', AUDIO_MIME_TYPE);

            audio.append(source);
            $('body').append(audio);

            audio.get(0).play();
        }
        catch (e) {
            logConsole('createBgmNode = ' + e.message);
        }
    }

    function controlBgm(control, callback) {
        if(HAS_MUSIC == 0) {
            return Promise.resolve();
        }

        try {
            var audio = $('#bgm');
            var MEDIA_START_UP = localStorage.getItem('MEDIA_START_UP');

            if(isPreviewMode()) {
                controlBgmInPreview(audio, control);
                return Promise.resolve();
            }

            if (audio.length) {
                if (control == 1) {
                    if(MEDIA_START_UP == 0) {
                        return startMedia()
                            .then(function() {
                                audio.get(0).play();
                            });
                    } else {
                        audio.get(0).play();
                    }
                }
                else {
                    audio.remove();
                    if(MEDIA_START_UP == 1) {
                        return shutDownMedia(control, callback);
                    } else {
                        _.isFunction(callback) && callback();
                    }
                }
            } else {
                if(control == 1) {
                    createBgmNode();
                } else {
                    return shutDownMedia(control, callback);
                }
            }
        }
        catch (e) {
            logConsole('controlBgm = ' + e.message);
            return Promise.reject(e);
        }
        return Promise.resolve();
    }

    function controlBgmInPreview(audio, control) {
        if(audio.length) {
            if(control === 1) {
                audio.get(0).play();
            }
            else {
                audio.get(0).pause();
            }
        }
        else {
            if(control === 1) {
                createBgmNode();
            }
        }
    }

    function soundMute() {
        if(GLOBAL_SOUND_SETTING != 0) {
            return Promise.resolve();
        }

        if(!isPreviewMode()) {
            return hcapPromise.volume.getVolumeLevel({
                'onSuccess' : function(s) {
                    //logConsole('onSuccess : level = ' + s.level);

                    if(Number(s.level) != -1) {
                        localStorage.setItem('tv_sound', s.level);

                        return hcapPromise.volume.setVolumeLevel({
                                'level' : -1,
                                'onSuccess' : function() {
                                    //logConsole('onSuccess Sound Mute');
                                },
                                'onFailure' : function(f) {
                                    logConsole('onFailure : errorMessage = ' + f.errorMessage);
                                }
                        });
                    }
                },
                'onFailure' : function(f) {
                    logConsole('onFailure : errorMessage = ' + f.errorMessage);
                }
            });
        }
    }

    function soundOn() {
        if(GLOBAL_SOUND_SETTING != 0) {
            return Promise.resolve();
        }

        var currentVolume = 10;

        try {
            var tvSoundVolume = localStorage.getItem('tv_sound');
            if(!isPreviewMode()) {
                return hcapPromise.volume.getVolumeLevel({
                    'onSuccess' : function(s) {
                        //logConsole('onSuccess : level = ' + s.level);

                        if(tvSoundVolume != null) {
	                        currentVolume = Number(tvSoundVolume);

	                        if(Number(s.level) != -1) {
	                            if(currentVolume != s.level) {
	                                currentVolume = s.level;
	                            }
	                        }
                        }
                        else {
                        	if(Number(s.level) != -1) {
                            	currentVolume = s.level;
                            }
                        }
                        setVolume(currentVolume);
                    },
                    'onFailure' : function(f) {
                        logConsole('onFailure : errorMessage = ' + f.errorMessage);
                    }
                });
            }
        } catch (e) {
            logConsole('soundOn = ' + e.message);
        }
    }

    function setVolume(vol) {
        if(!isPreviewMode()) {
            return hcapPromise.volume.setVolumeLevel({
                'level' : vol,
                'onSuccess' : function() {

                	/* Need to set volume in local storage when sound is turned on,
                	* otherwise the previous value from 'mute' is still in local storage.
                	* When smartapp is launched it mutes the sound instead of unmuting it.*/
                	localStorage.setItem('tv_sound', vol);

                    //logConsole('onSuccess Sound On');
                },
                'onFailure' : function(f) {
                    logConsole('onFailure : errorMessage = ' + f.errorMessage);
                }
            });
        }
        else {
            return Promise.resolve();
        }
    }

    return {
        task: task,
        runTask: runTask,
        init: init,
        controlBgm: controlBgm,
        createBgmNode: createBgmNode,
        soundMute: soundMute,
        soundOn: soundOn,
        setVolume: setVolume
    };
}());

function setVolume(vol) {
    BGM.task(setVolume, vol);
}

function controlBgm(control, callback) {
    BGM.task("controlBgm", control, callback);
}

function soundMute() {
    BGM.task("soundMute");
}

function soundOn() {
    BGM.task("soundOn");
}

if(HAS_MUSIC == 1 && IS_TV_WIDGET_IN_PORTAL == 'N') {
    BGM.task("createBgmNode");
}
